/* 
 * Page RequireCartouche
 * 
 */

"use strict";

var btValCart = null;
var RequireCartouche_stgyCallMsgBulk = null;
var MvtParts = { // MovementParts
//  id                className         codeToSend
    None           : ["Move_None",    "0x0000, None"],
    MoveAhead      : ["Move_Ahead",   "0x2100, Move_Ahead"],
    MoveBack       : ["Move_Back",    "0x21B4, Move_Back"],
    Move90Right    : ["Move_90Right", "0x245A, Move_90Right"],
    Move90Left     : ["Move_90Left",  "0x245C, Move_90Left"],
    Move180Right   : ["Move_180Right","0x22B4, Move_180Right"],
    Move180Left    : ["Move_180Left", "0x22B6, Move_180Left"],
    Standby        : ["Veille",       "0x8822, Enrichment_Standby"]
    };

function RequireCartouche_init() {
    // populate the children of the cartouche
    var Crt = document.getElementById("Cartouche");
    for(var i = 0; i<10; ++i){ // draw numeric references ...
        var el = document.getElementById("Mvt_tpl").cloneNode(true);
        el.id = "Mvt0{0}_{1}".format(Math.floor(1+(i/2)),1+(i%2));
        el.idx = "{0}-{1}".format(Math.floor(1+(i/2)),1+(i%2));
        setMovementPart(el, MvtParts.None);
        Crt.appendChild(el);
        
    }
    // le bouton de validation
    var btValCart = document.getElementById("ValCart");
    if(btValCart) 
        btValCart.addEventListener("click", RequireCartouche__onSendCartouche, false);
    
    // Empêcher l'action de navigateur par défaut sur la page ...
    document.getElementById("RoundRequireCartouche").ondblclick = function()
    {
        return false;
    };
    
    document.onselectstart=function(){return false;};
    
    // ajoute action quand dblClick sur les tuiles de commande
    var cells = document.querySelectorAll("#RoundRequireCartouche > div");
    for (var i = 0; i < cells.length; i++) {
        if(cells[i].id.substring(0, 4) === "Move")
            cells[i].addEventListener("dblclick", RequireCartouche__onSetMovement, false);
        else if(cells[i].id.substring(0, 6) === "Veille")
            cells[i].addEventListener("dblclick", RequireCartouche__onSetMovement, false);
        else if(cells[i].id.substring(0, 5) === "Clear")
            cells[i].addEventListener("dblclick", clearAll, false);
    }
      
    // gestion des événements 'touch event' pour les écrans tactiles
    for (var i = 0; i < cells.length; i++) {
        var el = cells[i];
        el.addEventListener("touchstart", onTouchStart, false);
        el.addEventListener("touchend", onTouchEnd, false);
        el.addEventListener("touchcancel", onTouchCancel, false);
        el.addEventListener("touchleave", onTouchLeave, false);
        el.addEventListener("touchmove", onTouchMove, false);
    }
}

var _touchTargetFrom = null;
function onTouchStart(evt) {
  evt.preventDefault();
  _touchTargetFrom = evt.target;
}
function onTouchMove(evt) {
  //evt.preventDefault();
}
function onTouchEnd(evt) {
  if(_touchTargetFrom===null) return;
  evt.preventDefault();
  //var targetTo = evt.target;
    if(_touchTargetFrom.id.substring(0, 4) === "Move" || _touchTargetFrom.id.substring(0, 6) === "Veille")
        setMovement(_touchTargetFrom, null);
    else if(_touchTargetFrom.id.substring(0, 5) === "Clear")
        clearAll();
}
function onTouchCancel(evt) {
  evt.preventDefault();
  _touchTargetFrom = null;
}
function onTouchLeave(evt) {
  evt.preventDefault();
  _touchTargetFrom = null;
}

function RequireCartouche_RoundRequireCartouche(msgBulk)
{
    RequireCartouche_stgyCallMsgBulk = msgBulk;
    window.addEventListener("keyup", checkKeyboard, false);
}
function RequireCartouche__onSendCartouche()
{
    var msgBulk = DR2D_WSAPI.extractReplyFromCall(RequireCartouche_stgyCallMsgBulk);
    var cartouche = [];
    
    for(var i=1; i<6; ++i) // fill the cartouche ...
    {
        var cells = document.querySelectorAll("#Cartouche > div[id^=Mvt0"+i+"]");
        var items = [].slice.call(cells);
        var movement = [];
        items.forEach(function(el) { 
            var mvtPart = el.mvtPart;
            if(mvtPart)
                movement.push(mvtPart[1]); 
        });
        cartouche.push(movement);
    }  
    
    msgBulk.stgyReply.argsRef.cartouche = cartouche;
    DR2D_WSAPI.sendReply(msgBulk);
    
    window.removeEventListener("keyup", checkKeyboard, false);
    waitForRequireCartouche2();
}

function RequireCartouche__onSetMovement(ev){
    setMovement(ev.currentTarget, null);
}
function dragStart(ev) {
   ev.dataTransfer.effectAllowed='move';
   ev.dataTransfer.setData("Text", ev.target.getAttribute('id'));
   ev.dataTransfer.setDragImage(ev.target,ev.target.clientWidth/2,ev.target.clientHeight/2);
   return true;
}
function dragEnter(ev) {
   var srcId = ev.dataTransfer.getData("Text");
   if( srcId.substring(0, 3) === "Mvt") 
       ev.dataTransfer.dropEffect ='copy';
   if( srcId.substring(0, 3) === "Car")
       ev.dataTransfer.dropEffect ='none';
   //event.preventDefault();
   return true;
}
function dragOver(ev) {
    return false;
}
function dragDrop(ev) {
   var srcId = ev.dataTransfer.getData("Text");
   var srcElem = document.getElementById(srcId);
   var tgtElem = ev.target;
   var tgtId = tgtElem.id;
   if(srcId !== tgtId)
   {
        if( srcId.substring(0, 3) === "Mvt")
        { // set a 'NoMove'
            setMovementPart(srcElem, MvtParts.None);
        }else if(tgtId.substring(0, 3) === "Mvt") 
        { // add and action
            if(srcElem.id==="Move_Ahead")
                setMovementPart(tgtElem, MvtParts.MoveAhead);
            else if(srcElem.id==="Move_Back")
                setMovementPart(tgtElem, MvtParts.MoveBack);
            else if(srcElem.id==="Move_90Right")
                setMovementPart(tgtElem, MvtParts.Move90Right);
            else if(srcElem.id==="Move_90Left")
                setMovementPart(tgtElem, MvtParts.Move90Left);
            else if(srcElem.id==="Move_180Right")
                setMovementPart(tgtElem, MvtParts.Move180Right);
            else if(srcElem.id==="Move_180Left")
                setMovementPart(tgtElem, MvtParts.Move180Left);
            else if(srcElem.id==="Veille")
                setMovementPart(tgtElem, MvtParts.Standby); 
            else
                return false; // jamais dans ce cas !
        }
   }else if( srcId.substring(0, 4) === "Cart")
   { 
       clearAll(); // clear all entries
   } 
   
   ev.stopPropagation();
   return false;
}

function setMovement(srcElem, tgtElem)
{
    if(srcElem.id==="Move_Ahead")
        setMovementPart(tgtElem, MvtParts.MoveAhead);
    else if(srcElem.id==="Move_Back")
        setMovementPart(tgtElem, MvtParts.MoveBack);
    else if(srcElem.id==="Move_90Right")
        setMovementPart(tgtElem, MvtParts.Move90Right);
    else if(srcElem.id==="Move_90Left")
        setMovementPart(tgtElem, MvtParts.Move90Left);
    else if(srcElem.id==="Move_180Right")
        setMovementPart(tgtElem, MvtParts.Move180Right);
    else if(srcElem.id==="Move_180Left")
        setMovementPart(tgtElem, MvtParts.Move180Left);
    else if(srcElem.id==="Veille")
        setMovementPart(tgtElem, MvtParts.Standby); 
    else
        return false; // jamais dans ce cas !
}

///> efface l'ensemble des mouvements de la cartouche
function clearAll()
{
    var cells = document.querySelectorAll("#Cartouche > div[id^=Mvt0]");
    var items = [].slice.call(cells);
    items.forEach(function(elem) { 
        setMovementPart(elem, MvtParts.None);
    });
}

///> ajoute le sous mouvement au premier emplacement libre et cohérent.
function setMovementPart(tgtElem, mvtPart){
    if(tgtElem === null){ // trouve la première place libre
        var cells = document.querySelectorAll("#Cartouche > div[id^=Mvt0]");
        var items = [].slice.call(cells);
        if(items[9].mvtPart!==MvtParts.None) return; // plus de place!
        
        var selElem = null;
        var selIdx = 0;
        var idx=0;
        items.forEach(function(elem) { 
            if(elem.mvtPart!==MvtParts.None) {selElem = elem; selIdx = idx;}
            idx++;
        });
        if(selIdx===9) return; // plus de place!
        else if(selElem === null) selElem = items[0];
        else if(selElem.mvtPart!==MvtParts.None)
        {
            selIdx++; selElem = items[selIdx]; // la case libre
        } 
        
        var prevElem = items[selIdx-1];
        if( (mvtPart === MvtParts.MoveAhead || mvtPart === MvtParts.MoveBack) 
         && ((selIdx%2) === 1) 
         && (prevElem.mvtPart === MvtParts.MoveAhead || prevElem.mvtPart === MvtParts.MoveBack))
        {
            if(selIdx <9) selElem = items[selIdx+1];
            else return; // plus de place!
        }
        tgtElem = selElem;
        console.assert(tgtElem.mvtPart === MvtParts.None);
    }
    
    tgtElem.className = mvtPart[0];
    tgtElem.mvtPart = mvtPart;
    if(mvtPart===MvtParts.None)
        tgtElem.firstChild.textContent = tgtElem.idx;
    else
        tgtElem.firstChild.textContent = ".";
}

///> associe des racourcis clavier
function checkKeyboard(myEvt) {
    console.log(">>> Keyboard: "+myEvt.keyCode);
    var tgtElem = null;
    switch(myEvt.keyCode)
    {
        case 104 : setMovementPart(tgtElem, MvtParts.MoveAhead); break;    // 8
        case 98  : setMovementPart(tgtElem, MvtParts.MoveBack); break;     // 2
        case 100 : setMovementPart(tgtElem, MvtParts.Move90Left); break;   // 4
        case 102 : setMovementPart(tgtElem, MvtParts.Move90Right); break;  // 6
        case 97  : setMovementPart(tgtElem, MvtParts.Move180Left); break;  // 1
        case 99  : setMovementPart(tgtElem, MvtParts.Move180Right); break; // 3
        case 96  : setMovementPart(tgtElem, MvtParts.Standby); break;      // 0
        case 109 : clearAll(); break;                                      // - 
        //case 27  : clearAll(); break;                                     // ESC
        case 13  : RequireCartouche__onSendCartouche(); break;            // CR
        default  : setMovementPart(tgtElem, MvtParts.None); break;
    }
}
